//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "AHGduP"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 EMPTY 
#property indicator_color2 EMPTY 
#property indicator_color3 EMPTY 
#property indicator_color4 EMPTY 
#property indicator_color5 EMPTY 

extern int    PeriodRSI             = 13;
extern int    PeriodStoch           = 8;
extern int    PeriodSK              = 5;
extern int    PeriodSD              = 3;
extern int    MAMode                = 3;
extern double SmoothPeriod          = 5;
extern int    SmoothPhase           = 0;
extern bool   SmoothDouble          = true;
extern int    MinMaxPeriod          = 50;
extern double LevelUp               = 95;//92
extern double LevelDown             =  5;//8

extern int DTosc5_Period       = 5 ;// extern int CCI5_Period
extern int DTosc15_Period      = 5 ;
extern int DTosc30_Period      = 5 ;
extern int DTosc60_Period      = 5 ;
extern int DTosc240_Period     = 5 ;

extern int        DTosc_WIN5D   = 1;
extern int        Adj_UpDn       = 20;//120
extern int        Adj_LtRt       = 30;//315
extern int        TextSize       = 10;
extern bool       ShowDots       = true;

double DTosc5W[];
double DTosc15W[];
double DTosc30W[];
double DTosc60W[];
double DTosc240W[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
 {
    IndicatorDigits(+2);
    IndicatorBuffers(5);
    SetIndexBuffer(0, DTosc5W);
    SetIndexBuffer(1, DTosc15W);
    SetIndexBuffer(2, DTosc30W);
    SetIndexBuffer(3, DTosc60W);
    SetIndexBuffer(4, DTosc240W);
 

//=============================MOD====================================================== 
         string  ThisName = "DTosc_WIN5D";
         string Text=ThisName;
         IndicatorShortName(Text); 
         SetIndexLabel(0,"");    
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
  {     Refresh();
        return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void start()
 {    Refresh();
      int add_y;
      int i,limit,LoopBegin=1;
//=====================================================================================================
      
      int HHE,HVE,  C5LH, C5LV,  C15LH,C15LV,   C30LH, C30LV,   C60LH, C60LV,   C240LH, C240LV ;
      int           C5LHD,       C15LHD,        C30LHD,         C60LHD,         C240LHD ;
  if  (DTosc_WIN5D==0)//
      {                
                         HHE    = 820 +Adj_LtRt;  HVE     = 150 +Adj_UpDn ; 
                        C5LH    = 820 +Adj_LtRt;  C5LV    = 170 +Adj_UpDn ; 
                        C15LH   = 820 +Adj_LtRt;  C15LV   = 190 +Adj_UpDn ; 
                        C30LH   = 820 +Adj_LtRt;  C30LV   = 210 +Adj_UpDn ; 
                        C60LH   = 820 +Adj_LtRt;  C30LV   = 230 +Adj_UpDn ; 
                        C240LH  = 820 +Adj_LtRt;  C240LV  = 250 +Adj_UpDn ; 
           //DOTS--             
                        C5LHD    = 850 +Adj_LtRt; 
                        C15LHD   = 850 +Adj_LtRt; 
                        C30LHD   = 850 +Adj_LtRt;  
                        C60LHD   = 850 +Adj_LtRt; 
                        C240LHD  = 850 +Adj_LtRt; 
                        
      }
   if  (DTosc_WIN5D==1||2||3||4)
      {                 
                        HHE     = 820 +Adj_LtRt;  HVE     = 10  +Adj_UpDn ; 
                        C5LH    = 820 +Adj_LtRt;  C5LV    = 25  +Adj_UpDn ; 
                        C15LH   = 820 +Adj_LtRt;  C15LV   = 45  +Adj_UpDn ; 
                        C30LH   = 820 +Adj_LtRt;  C30LV   = 65  +Adj_UpDn ; 
                        C60LH   = 820 +Adj_LtRt;  C60LV   = 85  +Adj_UpDn ; 
                        C240LH  = 820 +Adj_LtRt;  C240LV  = 105 +Adj_UpDn ; 
                        
           //DOTS--             
                        C5LHD    = 860 +Adj_LtRt;//850
                        C15LHD   = 860 +Adj_LtRt; 
                        C30LHD   = 860 +Adj_LtRt;  
                        C60LHD   = 860 +Adj_LtRt; 
                        C240LHD  = 860 +Adj_LtRt;             
      }

//========================================================================================== 
  
 for (i=LoopBegin; i>=0; i--) {
      
      DTosc5W[i]   = iCustom(NULL,PERIOD_M5 ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,3,i);
      DTosc15W[i]  = iCustom(NULL,PERIOD_M15,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,3,i);
      DTosc30W[i]  = iCustom(NULL,PERIOD_M30,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,3,i);
      DTosc60W[i]  = iCustom(NULL,PERIOD_H1, "DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,3,i);
      DTosc240W[i] = iCustom(NULL,PERIOD_H4 ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,3,i);
      
     double DTosc5WP     = DTosc5W[i+1];
     double DTosc15WP    = DTosc15W[i+1];
     double DTosc30WP    = DTosc30W[i+1];
     double DTosc60WP    = DTosc60W[i+1];
     double DTosc240WP   = DTosc240W[i+1];
     double DTosc5WPm   = iCustom(NULL,PERIOD_M5  ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,1,i);
     double DTosc15WPm  = iCustom(NULL,PERIOD_M15 ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,1,i);
     double DTosc30WPm  = iCustom(NULL,PERIOD_M30 ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,1,i);
     double DTosc60WPm  = iCustom(NULL,PERIOD_H1  ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,1,i);
     double DTosc240WPm = iCustom(NULL,PERIOD_H4  ,"DTosc","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,SmoothPeriod,SmoothPhase,SmoothDouble,MinMaxPeriod,LevelUp,LevelDown,false,false,false,false,0,0,"none",false,false,1,i);
      

//=======================  HEADINGE  ===============================================================================================================================================================================================+   
    
     ObjectCreate ("HEADINGE5D", OBJ_LABEL,DTosc_WIN5D, 0, 0);//****************************
     ObjectSetText("HEADINGE5D", "DTOSC 5/95" , TextSize, "Tahoma Bold", Gold);
     ObjectSet    ("HEADINGE5D", OBJPROP_XDISTANCE, HHE);
     ObjectSet    ("HEADINGE5D", OBJPROP_YDISTANCE, HVE); 

//=======================  CCI  =============================================================        
  
   { ObjectCreate("DToscT5_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0);
 if  (DTosc5W[i]>DTosc5WPm ){ObjectSetText("DToscT5_lab5","(5)          "+DoubleToStr(DTosc5W[i],1)+"", TextSize, "Tahoma Bold", Lime);}
 if  (DTosc5W[i]<DTosc5WPm ){ObjectSetText("DToscT5_lab5","(5)          "+DoubleToStr(DTosc5W[i],1)+"", TextSize, "Tahoma Bold", Red);}
     ObjectSet("DToscT5_lab5", OBJPROP_XDISTANCE, C5LH);
     ObjectSet("DToscT5_lab5", OBJPROP_YDISTANCE, C5LV ); 
   }
   
   { ObjectCreate("DToscT15_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0);
 if  (DTosc15W[i]>DTosc15WPm ){ObjectSetText("DToscT15_lab5","(15)        "+DoubleToStr(DTosc15W[i],1)+"", TextSize, "Tahoma Bold", Lime);}
 if  (DTosc15W[i]<DTosc15WPm ){ObjectSetText("DToscT15_lab5","(15)        "+DoubleToStr(DTosc15W[i],1)+"", TextSize, "Tahoma Bold", Red);}
     ObjectSet("DToscT15_lab5", OBJPROP_XDISTANCE, C15LH);
     ObjectSet("DToscT15_lab5", OBJPROP_YDISTANCE, C15LV ); 
   }
   
   { ObjectCreate("DToscT30_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0);
 if  (DTosc30W[i]>DTosc30WPm ){ObjectSetText("DToscT30_lab5","(30)        "+DoubleToStr(DTosc30W[i],1)+"", TextSize, "Tahoma Bold", Lime);}
 if  (DTosc30W[i]<DTosc30WPm ){ObjectSetText("DToscT30_lab5","(30)        "+DoubleToStr(DTosc30W[i],1)+"", TextSize, "Tahoma Bold", Red);}
     ObjectSet("DToscT30_lab5", OBJPROP_XDISTANCE, C30LH);
     ObjectSet("DToscT30_lab5", OBJPROP_YDISTANCE, C30LV ); 
   }
   
   { ObjectCreate("DToscT60_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0);
 if  (DTosc60W[i]>DTosc60WPm ){ObjectSetText("DToscT60_lab5","(H1)        "+DoubleToStr(DTosc60W[i],1)+"", TextSize, "Tahoma Bold", Aqua);}//Lime
 if  (DTosc60W[i]<DTosc60WPm ){ObjectSetText("DToscT60_lab5","(H1)        "+DoubleToStr(DTosc60W[i],1)+"", TextSize, "Tahoma Bold", Yellow);}//Red
     ObjectSet("DToscT60_lab5", OBJPROP_XDISTANCE, C60LH);
     ObjectSet("DToscT60_lab5", OBJPROP_YDISTANCE, C60LV ); 
   }
   
   { ObjectCreate("DToscT240_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0);
 if  (DTosc240W[i]>DTosc240WPm ){ObjectSetText("DToscT240_lab5","(H4)        "+DoubleToStr(DTosc240W[i],1)+"", TextSize, "Tahoma Bold", Lime);}
 if  (DTosc240W[i]<DTosc240WPm ){ObjectSetText("DToscT240_lab5","(H4)        "+DoubleToStr(DTosc240W[i],1)+"", TextSize, "Tahoma Bold", Red);}
     ObjectSet("DToscT240_lab5", OBJPROP_XDISTANCE, C240LH);
     ObjectSet("DToscT240_lab5", OBJPROP_YDISTANCE, C240LV ); 
   }
   
//====================== DOT DIRECTION ===============================================================================================+
 if      (  ShowDots == true ){
     { ObjectCreate("DToscT5D_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0); 
 //if  ((CCI5W[i] > 50 )&& (CCI5W[i] > CCI5WP )) {ObjectSetText("CCIT5D_lab5","",10, "Wingdings", Lime);}
 //if  ((CCI5W[i] > 50 )&& (CCI5W[i] < CCI5WP )) {ObjectSetText("CCIT5D_lab5","",10, "Wingdings", MediumSeaGreen);}
 if  ( (DTosc5W[i] > DTosc5WP )) {ObjectSetText("DToscT5D_lab5","",10, "Wingdings", Lime);}
 if  ( (DTosc5W[i] < DTosc5WP )) {ObjectSetText("DToscT5D_lab5","",10, "Wingdings", Red);}
 
//f  ( (CCI5W[i] > CCI5WP )) {ObjectSetText("CCIT5D_lab5","",10, "Wingdings", Red);}
 //  ( (CCI5W[i] < CCI5WP )) {ObjectSetText("CCIT5D_lab5","",10, "Wingdings", IndianRed);}
     ObjectSet("DToscT5D_lab5", OBJPROP_XDISTANCE, C5LHD);
     ObjectSet("DToscT5D_lab5", OBJPROP_YDISTANCE, C5LV ); 
   }
   
   { ObjectCreate("DToscT15D_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0); 
 if  ( (DTosc15W[i] > DTosc15WP )) {ObjectSetText("DToscT15D_lab5","",10, "Wingdings", Lime);}
 if  ( (DTosc15W[i] < DTosc15WP )) {ObjectSetText("DToscT15D_lab5","",10, "Wingdings", Red);}
     ObjectSet("DToscT15D_lab5", OBJPROP_XDISTANCE, C15LHD);
     ObjectSet("DToscT15D_lab5", OBJPROP_YDISTANCE, C15LV ); 
   }
   
   { ObjectCreate("DToscT30D_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0); 
 if  ( (DTosc30W[i] > DTosc30WP )) {ObjectSetText("DToscT30D_lab5","",10, "Wingdings", Lime);}
 if  ( (DTosc30W[i] < DTosc30WP )) {ObjectSetText("DToscT30D_lab5","",10, "Wingdings", Red);}
     ObjectSet("DToscT30D_lab5", OBJPROP_XDISTANCE, C30LHD);
     ObjectSet("DToscT30D_lab5", OBJPROP_YDISTANCE, C30LV ); 
   }
   
   { ObjectCreate("DToscT60D_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0); 
 if  ( (DTosc60W[i] > DTosc60WP )) {ObjectSetText("DToscT60D_lab5","",10, "Wingdings", Lime);}
 if  ( (DTosc60W[i] < DTosc60WP )) {ObjectSetText("DToscT60D_lab5","",10, "Wingdings", Red);}
     ObjectSet("DToscT60D_lab5", OBJPROP_XDISTANCE, C60LHD);
     ObjectSet("DToscT60D_lab5", OBJPROP_YDISTANCE, C60LV ); 
   }
   
   { ObjectCreate("DToscT240D_lab5", OBJ_LABEL,DTosc_WIN5D, 0, 0); 
 if  ( (DTosc240W[i] > DTosc240WP )) {ObjectSetText("DToscT240D_lab5","",10, "Wingdings", Lime);}
 if  ( (DTosc240W[i] < DTosc240WP )) {ObjectSetText("DToscT240D_lab5","",10, "Wingdings", Red);}
     ObjectSet("DToscT240D_lab5", OBJPROP_XDISTANCE, C240LHD);
     ObjectSet("DToscT240D_lab5", OBJPROP_YDISTANCE, C240LV ); 
     Comment(DTosc240W[i],"    ",DTosc240WP);
   }
   }
//===================================================================================================+  
     }
     }
//====================================================================
void Refresh() 
   {              
     
      ObjectDelete("HEADINGE5D");   
        
      ObjectDelete("DToscT5_lab5");   
      ObjectDelete("DToscT15_lab5");   
      ObjectDelete("DToscT30_lab5");
      ObjectDelete("DToscT60_lab5");    
      ObjectDelete("DToscT240_lab5"); 
      
      ObjectDelete("DToscT5D_lab5"); 
      ObjectDelete("DToscT15D_lab5"); 
      ObjectDelete("DToscT30D_lab5"); 
      ObjectDelete("DToscT60D_lab5");  
      ObjectDelete("DToscT240D_lab5"); 
   }
 
//------------------------------------------------------------------------------------+

